module.exports = {
  name: "app-service-uc",
  source: "./src",
  distFolderName: 'dist',
  main: './index.js',
  watch: [],
  uglify: false,
  watchIgnore: /[\/\\]\./,
  server: "http://localhost:6106",
  cloudHub: "http://localhost:6080?username=test&password=123456",
  gateway: false,
  generate: {
    host: "192.168.3.46",
    user: "root",
    port: "3306",
    password: "password",
    database: "ada-uc",
    charset: "utf8",
    waitForConnections: true,
    connectionLimit: 10,
    queueLimit: 0,
    output: "/Users/wangjinliang/adacloud/util/test",
    consumer: []
  },
  dependence: {
    base: {
      "uglify-es": "^3.3.8",
      "@babel/cli": "^7.1.0",
      "@babel/core": "^7.1.0",
      "@babel/runtime-corejs2": "^7.1.2",
      "@babel/plugin-proposal-class-properties": "^7.1.0",
      "@babel/plugin-proposal-decorators": "^7.0.0-beta.52",
      "@babel/plugin-proposal-do-expressions": "^7.0.0",
      "@babel/plugin-proposal-function-bind": "^7.0.0",
      "@babel/plugin-proposal-object-rest-spread": "^7.0.0",
      "@babel/plugin-syntax-dynamic-import": "^7.0.0",
      "@babel/plugin-syntax-export-extensions": "^7.0.0-beta.32",
      "@babel/plugin-transform-async-to-generator": "^7.1.0",
      "@babel/plugin-transform-runtime": "^7.1.0",
      "@babel/polyfill": "^7.0.0",
      "@babel/preset-env": "^7.1.0",
      "@babel/preset-typescript": "^7.1.0",
      "@babel/register": "^7.0.0",
      "@babel/runtime": "^7.0.0"
    },
    maker: "./maker/jsmaker"
  },
  compiler: {
    babel: {
      presets: [
        "@babel/typescript", ["@babel/env", { "targets": { "chrome": "75" } }]
      ],
      plugins: [
        ["@babel/plugin-transform-runtime", { "helpers": false, "regenerator": true }],
        ["@babel/plugin-proposal-decorators", { "legacy": true }],
        ["@babel/plugin-proposal-class-properties", { "loose": true }],
        "@babel/transform-async-to-generator",
        "@babel/plugin-syntax-dynamic-import",
        "@babel/plugin-proposal-function-bind",
        "@babel/plugin-syntax-export-extensions",
        "@babel/plugin-proposal-do-expressions",
        "@babel/plugin-proposal-object-rest-spread"
      ]
    },
    uglify: {}
  },
  logger: {
    hub: [
      {
        outputer: 'console', level: 'all', formater: [
          { type: 'info' },
          { type: 'cli' }
        ]
      }
    ],
    boost: [
      {
        outputer: 'console', level: 'all', formater: [
          { type: 'info' },
          { type: 'cli' }
        ]
      }
    ],
    'boost-major': [
      {
        outputer: 'console', level: 'all', formater: [
          { type: 'info' },
          { type: 'major' }
        ]
      }
    ]
  }
};