const Metadata = require("./../metadata");

const annotation = {
    table(info) {
        return function (target) {
            Metadata.defindClassMetadata(target.prototype, { table: info });
        };
    },
    field(info = {}) {
        return function (target, property) {
            Metadata.definePropertyMetadata(target, property, info);
        }
    },
    channel() {
        return function (target, property) {
            Metadata.definePropertyMetadata(target, property, { channel: true });
        }
    },
    remoteService() {
        return function (target, property) {
            Metadata.definePropertyMetadata(target, property, { remoteService: true });
        }
    },
    remoteVerify() {
        return function (target, property) {
            Metadata.definePropertyMetadata(target, property, { remoteVerify: true });
        }
    },
    controller(info = {}) {
        return function (target) {
            Metadata.defindClassMetadata(target.prototype, { controller: info });
        }
    },
    action(info = {}) {
        return function (target, property) {
            Metadata.defineMethodMetadata(target, property, info);
        }
    },
    service(serviceClass) {
        return function (target, property) {
            if (property) {
                Metadata.definePropertyMetadata(target, property, { service: serviceClass });
            }
        }
    },
    transaction() {
        return function (target, property) {
            Metadata.defineMethodMetadata(target, property, { transaction: true });
        }
    },
    dao(daoClass) {
        return function (target, property) {
            if (property) {
                Metadata.definePropertyMetadata(target, property, { dao: daoClass });
            }
        }
    },
    datasource(dataSourceClass) {
        return function (target) {
            Metadata.defindClassMetadata(target.prototype, { datasource: dataSourceClass });
        }
    },
    database(name) {
        return function (target) {
            Metadata.defindClassMetadata(target.prototype, { database: name });
        }
    },
    consumer(info) {
        return function (target, property) {
            Metadata.defineMethodMetadata(target, property, { consumer: info });
        }
    }
};

module.exports = annotation;