const { SuccessResult, ErrorResult, LoginResult, UnauthorizedResult, NofoundResult, UnvalidResult, Result } = require("../../result");
const Metadata = require("../../metadata");
const BoostContext = require("../context");

const ResultMap = {
    success: SuccessResult,
    error: ErrorResult,
    login: LoginResult,
    unauth: UnauthorizedResult,
    nofound: NofoundResult,
    unavlid: UnvalidResult,
    base: Result
}

class Controller {
    beforeExcute({ context, action }) {
        return Promise.resolve();
    }

    afterExcute({ context, action }) {
        return Promise.resolve();
    }

    actionNotFound({ context, action }) {
        return Promise.resolve();
    }

    actionExcuteError({ context, action, error }) {
        return Promise.resolve();
    }

    getBoostContext() {
        return BoostContext.getContextInfo();
    }

    getResult(type, data) {
        if (ResultMap[type]) {
            return ResultMap[type](data);
        } else {
            return new Result();
        }
    }

    getClassMetaInfo() {
        return Metadata.getClassMetadataExtends(this.__proto__.constructor.prototype);
    }

    getMethodsMetaInfo() {
        return Metadata.getMethodMetadataExtends(this.__proto__.constructor.prototype);
    }

    get localStore() {
        return this._localStore;
    }
}

module.exports = Controller;