const mysql = require('mysql2');
const Datasource = require("./base");
const Metadata = require("./../../metadata");

class MySqlDatasource extends Datasource {
    initialize(option) {
        this.pool = mysql.createPool(option);
    }

    getConnection() {
        return new Promise((resolve, reject) => {
            this.pool.getConnection((err, conn) => {
                if (err) {
                    reject(err);
                } else {
                    resolve(conn.promise());
                }
            });
        });
    }

    releaseConnection(connection) {
        this.pool.releaseConnection(connection.connection);
    }

    update(config) {
        this.pool.end(err => {
            this.pool = mysql.createPool(config);
        });
    }
}

Metadata.defindClassMetadata(MySqlDatasource.prototype, { database: "defaultMysqlDatasource" });

module.exports = MySqlDatasource;