class LocalStore {
    constructor() {
        this._map = {};
        this._log = {};
    }

    get(key) {
        if (key) {
            return this._map[key];
        } else {
            return this._map;
        }
    }

    set(key, value) {
        if (arguments.length === 1) {
            Object.assign(this._map, key);
        } else {
            this._map[key] = value;
        }
        return this;
    }

    log(key, value) {
        if (arguments.length === 1) {
            Object.assign(this._log, key);
        } else {
            this._log[key] = value;
        }
        return this;
    }
}

module.exports = LocalStore;