let detectInstalled = require("detect-installed");
let config = require("./../../config");

const DependenceInstaller = {
	_installed: new Set(),
	_onstartinstall(names) {
		return config.get('hooker').excute("startInstall", names);
	},
	_onbeforeinstall(name) {
		return config.get('hooker').excute("beforeInstall", name);
	},
	_oninstalled(name) {
		return config.get('hooker').excute("afterInstall", name);
	},
	_oninstallerror(name) {
		return config.get('hooker').excute("installError", name);
	},
	checkUnInstallModules(names) {
		let result = new Set();
		return names.filter(a => !this._installed.has(a)).reduce((a, name) => {
			return a.then(() => {
				return detectInstalled(name, {
					local: true
				}).then(exists => {
					if (!exists) {
						result.add(name);
					}
				});
			});
		}, Promise.resolve()).then(() => [...result]);
	},
	installModules(result) {
		if (result.length > 0) {
			return result.reduce((a, name) => {
				return a.then(() => {
					return this._onbeforeinstall(name).then(() => {
						return new Promise((resolve, reject) => {
							let args = ["install", name, "--save-dev"];
							require("child_process").exec(`npm ${args.join(" ")}`, {
								encoding: "utf-8",
								cwd: config.projectPath
							}, (error, stdout, stderr) => {
								if (error) {
									reject(name);
								} else {
									resolve(name);
								}
							});
						}).then(name => {
							this._installed.add(name);
							return this._oninstalled(name);
						}).catch(name => {
							return this._oninstallerror(name);
						});
					});
				});
			}, Promise.resolve());
		} else {
			return Promise.resolve();
		}
	},
	ready() {
		let { base } = config.get('dependence');
		return this.checkUnInstallModules(Reflect.ownKeys(base)).then(list => {
			return this.installModules(list);
		});
	}
};

module.exports = DependenceInstaller;