let colors = require("colors");
let ora = require('ora');

module.exports = function (hooker) {
	let installSpinner = null;
	let mapSpinner = null;
	let mapTime = 0;
	hooker.hook("beforeInstall", (name) => {
		installSpinner = ora({ color: "yellow", text: "INSTALL " + name }).start();
	}).hook("afterInstall", (name) => {
		installSpinner && installSpinner.stop();
		console.log(`[ADA-CLOUD]`.grey, `INSTALL`.green, `|`.green, name);
	}).hook("installError", (name) => {
		installSpinner && installSpinner.stop();
		console.log(`[ADA-CLOUD]`.grey, `INSTALL`.red, `|`.green, name);
	}).hook("beforeCompile", (name) => {
		mapTime = new Date().getTime();
		mapSpinner = ora({ color: "yellow", text: "COMPILE" }).start();
	}).hook("afterCompile", () => {
		mapSpinner && mapSpinner.stop();
		console.log(`[ADA-CLOUD]`.grey, `COMPILE`.green, `|`.green, (new Date().getTime() - mapTime), `ms`.green);
	}).hook("compileError", (e) => {
		mapSpinner && mapSpinner.stop();
		console.log(`[ADA-CLOUD]`.grey, `COMPILE`.red, `|`.green, (new Date().getTime() - mapTime), `ms`.green);
		console.log(e);
	}).hook("serviceStart", () => {
		console.log(`[ADA-CLOUD]`.grey, `SERVICE STAERT`.green);
	}).hook("serviceStop", () => {
		console.log(`[ADA-CLOUD]`.grey, `SERVICE STOP`.green);
	});
	return hooker;
};