require("colors");
const BaseFormater = require("./base");

function formatDate(date, format) {
    if (arguments.length === 1) {
        format = date;
        date = new Date();
    }
    let map = {
        y: date.getFullYear(),
        M: (date.getMonth() + 1),
        d: date.getDate(),
        h: date.getHours(),
        m: date.getMinutes(),
        s: date.getSeconds(),
        q: date.getMilliseconds()
    };
    return Reflect.ownKeys(map).reduce((a, b) => {
        return a.replace(new RegExp(`[${b}]+`, "g"), (str) => {
            let value = map[b] + "";
            if (str.length !== value.length) {
                return str.length > value.length ? (Array.apply(null, Array(str.length - value.length)).map(() => "0").join("") + value) : value.substring(str.length);
            } else {
                return value;
            }
        });
    }, format);
}

class CliFormater extends BaseFormater {
    constructor(option) {
        super(Object.assign({
            error: 'red',
            default: 'white'
        }, option));
    }

    format(info) {
        return [
            `[${formatDate(new Date(info.timestamp), 'yyyy-MM-dd hh:mm:ss:qqq')}]`.cyan,
            `[${info.level}]`.gray,
            `${info.name}`.yellow,
            `${info.message}`[this.option[info.level] || this.option['default']]
        ].join(' ');
    }
}

module.exports = CliFormater;