import TestK from './test';
import Metadata from './metadata';

function annotation(info) {
    return function (a, b, c) {
        if (c) {
            if (c.value) {
                // console.log('=> method:', b);
                Metadata.defineMethodMetadata(a, b, info);
            } else {
                // console.log('=> property', b);
                Metadata.definePropertyMetadata(a, b, info);
            }
        } else {
            // console.log('=> class xxx mmm');
            Metadata.defindClassMetadata(a.prototype, info);
        }
    }
}

// @annotation('class')
// class Test {
//     constructor() {
//         this._name = 'test';
//     }

//     @annotation('prop')
//     age = 20

//     @annotation('method')
//     getName() {
//         return this._name;
//     }
// }

function table(name) {
    return function (a) {
        Metadata.defindClassMetadata(a.prototype, { table: name });
    }
}

function id() {
    return function (a, property) {
        Metadata.definePropertyMetadata(a, property, { id: true });
    }
}

function field(name) {
    return function (a, property) {
        Metadata.definePropertyMetadata(a, property, { field: name });
    };
}

@table('user')
class Model {
    @id()
    @field('id')
    id = ''

    @field('name')
    name = ''

    @field('age')
    age = 0

    @field('birthday')
    birthday = 100000
}

@path('/user')
class Controller {
    @service('userService')
    service = null

    @path("/login")
    login({ request }) {
        return this.service.login(request.query);
    }
}

@service('userService')
class Service {
    @dao('stock')
    dao = null;

    @transaction()
    login({ username, password }) {
        let model = new Model({ username, password });
        return this.dao.find(model);
    }
}

console.log(new TestK()._name);
console.log(Metadata.getMetadataExtends(Model.prototype));
console.log('===========');
console.log(Metadata.getClassMetadataExtends(Model.prototype));
// console.log(Metadata.getMethodMetadataExtends(Model.prototype));
// console.log(Metadata.getMethodMetadataExtends(Model.prototype, 'getName'));
console.log(Metadata.getPropertyMetadataExtends(Model.prototype));
console.log(Metadata.getPropertyMetadataExtends(Model.prototype, 'age'));
console.log(Metadata.getPropertyMetadata(Model.prototype));
console.log(Metadata.getPropertyMetadata(Model.prototype, 'age'));

export default Model;